/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is useragent toolbar.
 *
 * The Initial Developer of the Original Code is David Illsley.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Edmonds <aedmonds@mindspring.com>
 *  David Illsley <illsleydc@bigfoot.com>
 *  Pavol Vaskovic <pali@pali.sk>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

initInstall("Xscroll", "xscroll", "0.0.3");
xscrollDir = getFolder("Chrome", "xscroll");
setPackageFolder(xscrollDir);
var err = addDirectory("xscroll");

if (err == SUCCESS) {
  registerChrome(CONTENT | DELAYED_CHROME, getFolder(xscrollDir, "content"));
  err = performInstall();

  if (err == SUCCESS) {
	if (getPlatform() == 'unix')
	  setupUnixAllowAll();

	alert("Xscroll has been successfully installed. \n"
		  +"Please restart your browser to continue.");
  }
  else {
	alert("performInstal() failed. \n"
		  +"_____________________________\nError code:" + err);
	cancellInstall(err);
  }
}
else {
  alert("Failed to create directory. \n"
		+"You probably don't have appropriate permissions \n"
		+"_____________________________\nError code:" + err);
  cancellInstall(err);
}

function getPlatform()
{
  var platformStr, platformNode;
  if ('platform' in Install) {
	platformStr = new String(Install.platform);

	if (!platformStr.search(/.*Darwin/))
	  platformNode = 'unix';
	else if (!platformStr.search(/^Macintosh/))
	  platformNode = 'mac';
	else if (!platformStr.search(/^Win/))
	  platformNode = 'win';
	else if (!platformStr.search(/^OS\/2/))
	  platformNode = 'win';
	else
	  platformNode = 'unix';
  }
  else {
	if (getFolder("Mac System") != null)
	  platformNode = 'mac';
	else if (getFolder("Win System") != null)
	  platformNode = 'win';
	else
	  platformNode = 'unix';
  }
  return platformNode;
}

function setupUnixAllowAll() {
  logComment("Xscroll: Attempting to set unix permissions for all users.\n");

  initInstall("Xscroll", "xscroll", "0.0.3");
  var chmodArg = String("-R a+r ") + getFolder("Chrome", "xscroll");
  rootDir = getFolder("OS Drive");
  binDir = getFolder(rootDir, "bin");
  chmodCommand = getFolder(binDir, "chmod");
  File.execute(chmodCommand, chmodArg);

  if (err == SUCCESS) {
	err = performInstall();
	return true;
  }
  else {
	cancellInstall(err);
	return false;
  }
}

